##
##  knoxite.spec -- OpenPKG RPM Package Specification
##  Copyright (c) 2000-2019 OpenPKG Project <http://openpkg.org/>
##
##  Permission to use, copy, modify, and distribute this software for
##  any purpose with or without fee is hereby granted, provided that
##  the above copyright notice and this permission notice appear in all
##  copies.
##
##  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
##  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
##  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
##  IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
##  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
##  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
##  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
##  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
##  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
##  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
##  OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
##  SUCH DAMAGE.
##

#   package version
%define       V_opkg  20191228
%define       V_dist  20191228

#   package information
Name:         knoxite
Summary:      Secure Data Storage and Backup Tool
URL:          https://github.com/knoxite/knoxite
Vendor:       Christian Muehlhaeuser
Packager:     OpenPKG Project
Distribution: OpenPKG Community
Class:        EVAL
Group:        Filesystem
License:      AGPL
Version:      %{V_opkg}.%{V_dist}
Release:      20191228

#   list of sources
Source0:      http://download.openpkg.org/components/versioned/knoxite/knoxite-%{V_dist}.tar.xz
Patch0:       knoxite.patch

#   build information
BuildPreReq:  OpenPKG, openpkg >= 20160101, go
PreReq:       OpenPKG, openpkg >= 20160101

%description
    Knoxite is a secure data storage & backup system. It's secure:
    Knoxite uses AES-encryption to safely store your data. It's
    flexible: You can always extend your storage size or move your
    stored data to another machine. It's efficient: Knoxite cleverly
    de-duplicates your data before storing it and supports multiple
    compression algorithms. It connects: You can use multiple storage
    backends, even parallely: local disks, Dropbox, Amazon S3 & others.

%track
    prog knoxite:release = {
        version   = %{V_opkg}
        url       = https://github.com/knoxite/knoxite/releases
        regex     = (__VER__)\.tar\.gz
    }
    prog knoxite:snapshot = {
        version   = %{V_dist}
        url       = http://download.openpkg.org/components/versioned/knoxite/
        regex     = knoxite-(__VER__)\.tar\.xz
    }

%prep
    %setup -q -n knoxite
    %patch -p0

%build
    #   build program
    export GOPATH=`pwd`
    cd src/github.com/knoxite/knoxite
    go build -x -o knoxite

%install
    #   create directory hierarchy
    %{l_shtool} mkdir -f -p -m 755 \
        $RPM_BUILD_ROOT%{l_prefix}/bin

    #   install program
    %{l_shtool} install -c -s -m 755 \
        src/github.com/knoxite/knoxite/knoxite \
        $RPM_BUILD_ROOT%{l_prefix}/bin/

    #   determine installation files
    %{l_rpmtool} files -v -ofiles -r$RPM_BUILD_ROOT %{l_files_std}

%files -f files

%clean

